Index: asp3_wo_tecs/trunk/test/test_tmevt1.c
===================================================================
--- asp3_wo_tecs/trunk/test/test_tmevt1.c	(revision 305)
+++ asp3_wo_tecs/trunk/test/test_tmevt1.c	(revision 306)
@@ -3,5 +3,5 @@
  *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
- *  Copyright (C) 2014-2015 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2014-2016 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -50,5 +50,5 @@
  *  ã®è²¬ä»»ãè² ããªãï¼
  * 
- *  $Id: test_tmevt1.c 310 2015-02-08 13:46:46Z ertl-hiro $
+ *  $Id: test_tmevt1.c 738 2016-04-05 14:19:24Z ertl-hiro $
  */
 
@@ -81,5 +81,5 @@
  *	== TASK1ï¼åªå
 åº¦ï¼ä¸­ï¼==
- *	1:	sta_alm(ALM1, ALM1_RELTIM)
+ *	1:	sta_alm(ALM1, TEST_TIME_PROC) ... ALM1-1ãå®è¡éå§ããã¾ã§
  *		DO(prev_lefttim = UINT32_MAX)
  *		DO(wait_alarm1(&alarm1_flag1))
@@ -88,10 +88,10 @@
  *		RETURN
  *	== TASK1ï¼ç¶ãï¼==
- *	3:	sta_alm(ALM1, ALM1_RELTIM)
+ *	3:	sta_alm(ALM1, TEST_TIME_PROC) ... ALM1-2ãå®è¡éå§ããã¾ã§
  *		DO(prev_lefttim = UINT32_MAX)
  *		DO(wait_alarm1(&alarm1_flag2))
  *	== ALM1-2ï¼2åç®ï¼==
  *	4:	DO(alarm1_flag2 = true)
- *	5:	sta_alm(ALM1, ALM1_RELTIM)
+ *	5:	sta_alm(ALM1, TEST_TIME_CP) ... ALM1-3ãå®è¡éå§ããã¾ã§
  *		DO(prev_lefttim = UINT32_MAX)
  *		DO(skip_check = true)
@@ -103,11 +103,11 @@
  *		RETURN
  *	== TASK1ï¼ç¶ãï¼==
- *	8:	sta_alm(ALM1, ALM1_RELTIM * 4)
- *		DO(prev_lefttim = UINT32_MAX)
- *		DO(refer_alarm1())
- *  9:	dly_tsk(ALM1_RELTIM)
- *		DO(prev_lefttim -= ALM1_RELTIM)
- *		DO(refer_alarm1())
- *  10:	adj_tim(ALM1_RELTIM)
+ *	8:	sta_alm(ALM1, 3 * TEST_TIME_CP) ... ALM1-4ãå®è¡éå§ããã¾ã§
+ *		DO(prev_lefttim = UINT32_MAX)
+ *		DO(refer_alarm1())
+ *  9:	dly_tsk(TEST_TIME_CP) ... ã©ã®ãããªæéã§ãè¯ã
+ *		DO(prev_lefttim -= TEST_TIME_CP)
+ *		DO(refer_alarm1())
+ *  10:	adj_tim(TEST_TIME_CP)
  *		DO(wait_alarm1(&alarm1_flag4))
  *	== ALM1-4ï¼4åç®ï¼==
@@ -115,12 +115,12 @@
  *		RETURN
  *	== TASK1ï¼ç¶ãï¼==
- *	12:	sta_alm(ALM1, ALM1_RELTIM * 4)
- *		DO(prev_lefttim = UINT32_MAX)
- *		DO(refer_alarm1())
- *  13:	dly_tsk(ALM1_RELTIM)
- *		DO(prev_lefttim -= ALM1_RELTIM)
- *		DO(refer_alarm1())
- *  14:	adj_tim(-ALM1_RELTIM)
- *		DO(prev_lefttim += ALM1_RELTIM)
+ *	12:	sta_alm(ALM1, 4 * TEST_TIME_CP) ... ALM1-5ãå®è¡éå§ããã¾ã§
+ *		DO(prev_lefttim = UINT32_MAX)
+ *		DO(refer_alarm1())
+ *  13:	dly_tsk(TEST_TIME_CP) ... ã©ã®ãããªæéã§ãè¯ã
+ *		DO(prev_lefttim -= TEST_TIME_CP)
+ *		DO(refer_alarm1())
+ *  14:	adj_tim(-TEST_TIME_CP)
+ *		DO(prev_lefttim += TEST_TIME_CP)
  *	15:	DO(wait_alarm1(&alarm1_flag5))
  *	== ALM1-5ï¼5åç®ï¼==
@@ -128,10 +128,10 @@
  *		RETURN
  *	== TASK1ï¼ç¶ãï¼==
- *	17:	sta_alm(ALM1, ALM1_RELTIM * 6)
- *		sta_alm(ALM2, ALM1_RELTIM * 4)
- *		DO(prev_lefttim = UINT32_MAX)
- *		DO(refer_alarm1())
- *  18:	dly_tsk(ALM1_RELTIM)
- *		DO(prev_lefttim -= ALM1_RELTIM)
+ *	17:	sta_alm(ALM1, 4 * TEST_TIME_CP) ... ALM1-6ãå®è¡éå§ããã¾ã§
+ *		sta_alm(ALM2, 3 * TEST_TIME_CP) ... stp_almã§åæ­¢ããã¾ã§
+ *		DO(prev_lefttim = UINT32_MAX)
+ *		DO(refer_alarm1())
+ *  18:	dly_tsk(TEST_TIME_CP) ... ã©ã®ãããªæéã§ãè¯ã
+ *		DO(prev_lefttim -= TEST_TIME_CP)
  *		DO(refer_alarm1())
  *	19:	stp_alm(ALM2)
@@ -144,7 +144,7 @@
  *		RETURN
  *	== TASK1ï¼ç¶ãï¼==
- *	22:	sta_alm(ALM1, ALM1_RELTIM * 6)
- *		sta_alm(ALM2, ALM1_RELTIM * 4)
- *		sta_alm(ALM3, ALM1_RELTIM)
+ *	22:	sta_alm(ALM1, 3 * TEST_TIME_CP) ... ALM1-7ãå®è¡éå§ããã¾ã§
+ *		sta_alm(ALM2, 2 * TEST_TIME_CP) ... stp_almã§åæ­¢ããã¾ã§
+ *		sta_alm(ALM3, TEST_TIME_CP) ... ALM3-1ãå®è¡éå§ããã¾ã§
  *		DO(prev_lefttim = UINT32_MAX)
  *	23:	DO(wait_alarm1(&alarm1_flag7))
@@ -261,5 +261,5 @@
 
 		check_point(5);
-		ercd = sta_alm(ALM1, ALM1_RELTIM);
+		ercd = sta_alm(ALM1, TEST_TIME_CP);
 		check_ercd(ercd, E_OK);
 
@@ -350,5 +350,5 @@
 
 	check_point(1);
-	ercd = sta_alm(ALM1, ALM1_RELTIM);
+	ercd = sta_alm(ALM1, TEST_TIME_PROC);
 	check_ercd(ercd, E_OK);
 
@@ -358,5 +358,5 @@
 
 	check_point(3);
-	ercd = sta_alm(ALM1, ALM1_RELTIM);
+	ercd = sta_alm(ALM1, TEST_TIME_PROC);
 	check_ercd(ercd, E_OK);
 
@@ -369,5 +369,5 @@
 
 	check_point(8);
-	ercd = sta_alm(ALM1, ALM1_RELTIM * 4);
+	ercd = sta_alm(ALM1, 3 * TEST_TIME_CP);
 	check_ercd(ercd, E_OK);
 
@@ -377,13 +377,13 @@
 
 	check_point(9);
-	ercd = dly_tsk(ALM1_RELTIM);
-	check_ercd(ercd, E_OK);
-
-	prev_lefttim -= ALM1_RELTIM;
+	ercd = dly_tsk(TEST_TIME_CP);
+	check_ercd(ercd, E_OK);
+
+	prev_lefttim -= TEST_TIME_CP;
 
 	refer_alarm1();
 
 	check_point(10);
-	ercd = adj_tim(ALM1_RELTIM);
+	ercd = adj_tim(TEST_TIME_CP);
 	check_ercd(ercd, E_OK);
 
@@ -391,5 +391,5 @@
 
 	check_point(12);
-	ercd = sta_alm(ALM1, ALM1_RELTIM * 4);
+	ercd = sta_alm(ALM1, 4 * TEST_TIME_CP);
 	check_ercd(ercd, E_OK);
 
@@ -399,16 +399,16 @@
 
 	check_point(13);
-	ercd = dly_tsk(ALM1_RELTIM);
-	check_ercd(ercd, E_OK);
-
-	prev_lefttim -= ALM1_RELTIM;
+	ercd = dly_tsk(TEST_TIME_CP);
+	check_ercd(ercd, E_OK);
+
+	prev_lefttim -= TEST_TIME_CP;
 
 	refer_alarm1();
 
 	check_point(14);
-	ercd = adj_tim(-ALM1_RELTIM);
-	check_ercd(ercd, E_OK);
-
-	prev_lefttim += ALM1_RELTIM;
+	ercd = adj_tim(-TEST_TIME_CP);
+	check_ercd(ercd, E_OK);
+
+	prev_lefttim += TEST_TIME_CP;
 
 	check_point(15);
@@ -416,8 +416,8 @@
 
 	check_point(17);
-	ercd = sta_alm(ALM1, ALM1_RELTIM * 6);
-	check_ercd(ercd, E_OK);
-
-	ercd = sta_alm(ALM2, ALM1_RELTIM * 4);
+	ercd = sta_alm(ALM1, 4 * TEST_TIME_CP);
+	check_ercd(ercd, E_OK);
+
+	ercd = sta_alm(ALM2, 3 * TEST_TIME_CP);
 	check_ercd(ercd, E_OK);
 
@@ -427,8 +427,8 @@
 
 	check_point(18);
-	ercd = dly_tsk(ALM1_RELTIM);
-	check_ercd(ercd, E_OK);
-
-	prev_lefttim -= ALM1_RELTIM;
+	ercd = dly_tsk(TEST_TIME_CP);
+	check_ercd(ercd, E_OK);
+
+	prev_lefttim -= TEST_TIME_CP;
 
 	refer_alarm1();
@@ -449,11 +449,11 @@
 
 	check_point(22);
-	ercd = sta_alm(ALM1, ALM1_RELTIM * 6);
-	check_ercd(ercd, E_OK);
-
-	ercd = sta_alm(ALM2, ALM1_RELTIM * 4);
-	check_ercd(ercd, E_OK);
-
-	ercd = sta_alm(ALM3, ALM1_RELTIM);
+	ercd = sta_alm(ALM1, 3 * TEST_TIME_CP);
+	check_ercd(ercd, E_OK);
+
+	ercd = sta_alm(ALM2, 2 * TEST_TIME_CP);
+	check_ercd(ercd, E_OK);
+
+	ercd = sta_alm(ALM3, TEST_TIME_CP);
 	check_ercd(ercd, E_OK);
 
Index: asp3_wo_tecs/trunk/test/test_tmevt1.h
===================================================================
--- asp3_wo_tecs/trunk/test/test_tmevt1.h	(revision 305)
+++ asp3_wo_tecs/trunk/test/test_tmevt1.h	(revision 306)
@@ -3,5 +3,5 @@
  *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
- *  Copyright (C) 2014 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2016 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -50,5 +50,5 @@
  *  ã®è²¬ä»»ãè² ããªãï¼
  * 
- *  $Id: test_tmevt1.h 286 2014-11-29 07:51:11Z ertl-hiro $
+ *  $Id: test_tmevt1.h 737 2016-04-05 13:11:23Z ertl-hiro $
  */
 
@@ -82,7 +82,12 @@
 #endif /* STACK_SIZE */
 
-#ifndef ALM1_RELTIM
-#define ALM1_RELTIM		200U		/* ã¢ã©ã¼ã ãã³ãã©1ã«ä»æããç¸å¯¾æé */
-#endif /* ALM1_RELTIM */
+#ifndef TEST_TIME_CP
+#define TEST_TIME_CP	50000U		/* ãã§ãã¯ãã¤ã³ãå°éæ
+å ±ã®åºåæé */
+#endif /* TEST_TIME_CP */
+
+#ifndef TEST_TIME_PROC
+#define TEST_TIME_PROC	1000U		/* ãã§ãã¯ãã¤ã³ããéããªãå ´åã®æé */
+#endif /* TEST_TIME_PROC */
 
 /*
Index: asp3_wo_tecs/trunk/test/testexec.rb
===================================================================
--- asp3_wo_tecs/trunk/test/testexec.rb	(revision 305)
+++ asp3_wo_tecs/trunk/test/testexec.rb	(revision 306)
@@ -52,5 +52,5 @@
 #  ã®è²¬ä»»ãè² ããªãï¼
 # 
-#  $Id: testexec.rb 600 2016-02-07 11:46:22Z ertl-hiro $
+#  $Id: testexec.rb 675 2016-03-06 01:30:21Z ertl-hiro $
 # 
 
@@ -63,72 +63,72 @@
 TEST_SPEC = {
   # æ©è½ãã¹ããã­ã°ã©ã 
-  "cpuexc1"  => { :SRC=>"test_cpuexc1", :CFG=>"test_cpuexc" },
-  "cpuexc2"  => { :SRC=>"test_cpuexc2", :CFG=>"test_cpuexc" },
-  "cpuexc3"  => { :SRC=>"test_cpuexc3", :CFG=>"test_cpuexc" },
-  "cpuexc4"  => { :SRC=>"test_cpuexc4", :CFG=>"test_cpuexc" },
-  "cpuexc5"  => { :SRC=>"test_cpuexc5", :CFG=>"test_cpuexc" },
-  "cpuexc6"  => { :SRC=>"test_cpuexc6", :CFG=>"test_cpuexc" },
-  "cpuexc7"  => { :SRC=>"test_cpuexc7", :CFG=>"test_cpuexc" },
-  "cpuexc8"  => { :SRC=>"test_cpuexc8", :CFG=>"test_cpuexc" },
-  "cpuexc9"  => { :SRC=>"test_cpuexc9", :CFG=>"test_cpuexc" },
-  "cpuexc10" => { :SRC=>"test_cpuexc10", :CFG=>"test_cpuexc" },
-  "dlynse"   => { :SRC=>"test_dlynse" },
-  "dtq1"     => { :SRC=>"test_dtq1" },
-  "flg1"     => { :SRC=>"test_flg1" },
-  "hrt1"     => { :SRC=>"test_hrt1" },
-  "mutex1"   => { :SRC=>"test_mutex1", :BIT=>"mutex" },
-  "mutex2"   => { :SRC=>"test_mutex2", :BIT=>"mutex" },
-  "mutex3"   => { :SRC=>"test_mutex3", :BIT=>"mutex" },
-  "mutex4"   => { :SRC=>"test_mutex4", :BIT=>"mutex" },
-  "mutex5"   => { :SRC=>"test_mutex5", :BIT=>"mutex" },
-  "mutex6"   => { :SRC=>"test_mutex6", :BIT=>"mutex" },
-  "mutex7"   => { :SRC=>"test_mutex7", :BIT=>"mutex" },
-  "mutex8"   => { :SRC=>"test_mutex8", :BIT=>"mutex" },
-  "notify1"  => { :SRC=>"test_notify1" },
-  "raster1"  => { :SRC=>"test_raster1", :BIT=>"kernel" },
-  "raster2"  => { :SRC=>"test_raster2" },
-  "sem1"     => { :SRC=>"test_sem1" },
-  "sem2"     => { :SRC=>"test_sem2" },
-  "sysman1"  => { :SRC=>"test_sysman1" },
-  "sysstat1" => { :SRC=>"test_sysstat1" },
-  "task1"    => { :SRC=>"test_task1", :BIT=>"kernel" },
-  "tmevt1"   => { :SRC=>"test_hrt1" },
+  "cpuexc1"  => { SRC: "test_cpuexc1", CFG: "test_cpuexc" },
+  "cpuexc2"  => { SRC: "test_cpuexc2", CFG: "test_cpuexc" },
+  "cpuexc3"  => { SRC: "test_cpuexc3", CFG: "test_cpuexc" },
+  "cpuexc4"  => { SRC: "test_cpuexc4", CFG: "test_cpuexc" },
+  "cpuexc5"  => { SRC: "test_cpuexc5", CFG: "test_cpuexc" },
+  "cpuexc6"  => { SRC: "test_cpuexc6", CFG: "test_cpuexc" },
+  "cpuexc7"  => { SRC: "test_cpuexc7", CFG: "test_cpuexc" },
+  "cpuexc8"  => { SRC: "test_cpuexc8", CFG: "test_cpuexc" },
+  "cpuexc9"  => { SRC: "test_cpuexc9", CFG: "test_cpuexc" },
+  "cpuexc10" => { SRC: "test_cpuexc10", CFG: "test_cpuexc" },
+  "dlynse"   => { SRC: "test_dlynse" },
+  "dtq1"     => { SRC: "test_dtq1" },
+  "flg1"     => { SRC: "test_flg1" },
+  "hrt1"     => { SRC: "test_hrt1" },
+  "mutex1"   => { SRC: "test_mutex1", BIT: "mutex" },
+  "mutex2"   => { SRC: "test_mutex2", BIT: "mutex" },
+  "mutex3"   => { SRC: "test_mutex3", BIT: "mutex" },
+  "mutex4"   => { SRC: "test_mutex4", BIT: "mutex" },
+  "mutex5"   => { SRC: "test_mutex5", BIT: "mutex" },
+  "mutex6"   => { SRC: "test_mutex6", BIT: "mutex" },
+  "mutex7"   => { SRC: "test_mutex7", BIT: "mutex" },
+  "mutex8"   => { SRC: "test_mutex8", BIT: "mutex" },
+  "notify1"  => { SRC: "test_notify1" },
+  "raster1"  => { SRC: "test_raster1", BIT: "kernel" },
+  "raster2"  => { SRC: "test_raster2" },
+  "sem1"     => { SRC: "test_sem1" },
+  "sem2"     => { SRC: "test_sem2" },
+  "sysman1"  => { SRC: "test_sysman1" },
+  "sysstat1" => { SRC: "test_sysstat1" },
+  "task1"    => { SRC: "test_task1", BIT: "kernel" },
+  "tmevt1"   => { SRC: "test_tmevt1" },
 
   # ã¡ãã»ã¼ã¸ãããã¡æ©è½æ¡å¼µããã±ã¼ã¸ã®æ©è½ãã¹ããã­ã°ã©ã 
-  "messagebuf1" => { :SRC=>"test_messagebuf1", :BIT=>"kernel" },
-  "messagebuf2" => { :SRC=>"test_messagebuf2", :BIT=>"kernel" },
+  "messagebuf1" => { SRC: "test_messagebuf1", BIT: "kernel" },
+  "messagebuf2" => { SRC: "test_messagebuf2", BIT: "kernel" },
 
   # ãªã¼ãã©ã³ãã³ãã©æ©è½æ¡å¼µããã±ã¼ã¸ã®æ©è½ãã¹ããã­ã°ã©ã 
-  "ovrhdr1"  => { :SRC=>"test_ovrhdr1" },
+  "ovrhdr1"  => { SRC: "test_ovrhdr1" },
 
   # å¶ç´ã¿ã¹ã¯æ¡å¼µããã±ã¼ã¸ã®æ©è½ãã¹ããã­ã°ã©ã 
-  "rstr1"    => { :SRC=>"test_rstr1" },
-  "rstr2"    => { :SRC=>"test_rstr2" },
+  "rstr1"    => { SRC: "test_rstr1" },
+  "rstr2"    => { SRC: "test_rstr2" },
 
   # ãµãåªå
 åº¦æ©è½æ¡å¼µããã±ã¼ã¸ã®æ©è½ãã¹ããã­ã°ã©ã 
-  "subprio1" => { :SRC=>"test_subprio1" },
-  "subprio2" => { :SRC=>"test_subprio2" },
+  "subprio1" => { SRC: "test_subprio1" },
+  "subprio2" => { SRC: "test_subprio2" },
 
   # ã·ã¹ãã æå»ç®¡çæ©è½ãã¹ããã­ã°ã©ã 
-  "systim1" => { :TARGET=>1, :SRC=>"hrt_systim1", :DEFS=>"-DHRT_CONFIG1" },
-  "systim2" => { :TARGET=>1, :SRC=>"hrt_systim2", :DEFS=>"-DHRT_CONFIG1" },
-  "systim3" => { :TARGET=>1, :SRC=>"hrt_systim3", :DEFS=>"-DHRT_CONFIG1" },
-  "systim4" => { :TARGET=>1, :SRC=>"hrt_systim4", :DEFS=>"-DHRT_CONFIG2" },
+  "systim1" => { TARGET: 1, SRC: "hrt_systim1", DEFS: "-DHRT_CONFIG1" },
+  "systim2" => { TARGET: 1, SRC: "hrt_systim2", DEFS: "-DHRT_CONFIG1" },
+  "systim3" => { TARGET: 1, SRC: "hrt_systim3", DEFS: "-DHRT_CONFIG1" },
+  "systim4" => { TARGET: 1, SRC: "hrt_systim4", DEFS: "-DHRT_CONFIG2" },
 
   # ããªããèª¿æ´æ©è½æ¡å¼µããã±ã¼ã¸ã®ã·ã¹ãã æå»ç®¡çæ©è½ãã¹ããã­ã°ã©ã 
-  "drift1"   => { :TARGET=>1, :SRC=>"hrt_drift1", :DEFS=>"-DHRT_CONFIG1" },
-  "drift1-64ops"  => { :TARGET=>1, :SRC=>"hrt_drift1",
-								:DEFS=>"-DHRT_CONFIG1 -DUSE_64BIT_OPS" },
-  "systim1-64ops" => { :TARGET=>1, :SRC=>"hrt_systim1",
-								:DEFS=>"-DHRT_CONFIG1 -DUSE_64BIT_OPS" },
+  "drift1"   => { TARGET: 1, SRC: "hrt_drift1", DEFS: "-DHRT_CONFIG1" },
+  "drift1-64ops"  => { TARGET: 1, SRC: "hrt_drift1",
+								DEFS: "-DHRT_CONFIG1 -DUSE_64BIT_OPS" },
+  "systim1-64ops" => { TARGET: 1, SRC: "hrt_systim1",
+								DEFS: "-DHRT_CONFIG1 -DUSE_64BIT_OPS" },
 
   # æ§è½è©ä¾¡ãã­ã°ã©ã 
-  "perf0" => { :CDL=>"perf_pf" },
-  "perf1" => { :CDL=>"perf_pf" },
-  "perf2" => { :CDL=>"perf_pf" },
-  "perf3" => { :CDL=>"perf_pf" },
-  "perf4" => { :CDL=>"perf_pf" },
-  "perf5" => { :CDL=>"perf_pf" },
+  "perf0" => { CDL: "perf_pf" },
+  "perf1" => { CDL: "perf_pf" },
+  "perf2" => { CDL: "perf_pf" },
+  "perf3" => { CDL: "perf_pf" },
+  "perf4" => { CDL: "perf_pf" },
+  "perf5" => { CDL: "perf_pf" },
 }
 
Index: asp3_wo_tecs/trunk/utils/gentest.rb
===================================================================
--- asp3_wo_tecs/trunk/utils/gentest.rb	(revision 305)
+++ asp3_wo_tecs/trunk/utils/gentest.rb	(revision 306)
@@ -52,5 +52,5 @@
 #  ã®è²¬ä»»ãè² ããªãï¼
 # 
-#  $Id: gentest.rb 578 2016-02-03 07:23:53Z ertl-hiro $
+#  $Id: gentest.rb 743 2016-04-10 16:00:40Z ertl-hiro $
 # 
 
@@ -62,76 +62,56 @@
 #  çæåä½ãæ±ºããããã®è¨­å®
 #
-$parameterPosition = {
-  "get_tst" => 2,
-  "get_pri" => 2,
-  "get_inf" => 1,
-  "ref_tsk" => 2,
-  "ref_sem" => 2,
-  "ref_flg" => 2,
-  "ref_dtq" => 2,
-  "ref_pdq" => 2,
-  "ref_mtx" => 2,
-  "ref_mbf" => 2,
-  "ref_mpf" => 2,
-  "get_tim" => 1,
-  "ref_cyc" => 2,
-  "ref_alm" => 2,
-  "ref_ovr" => 2,
-  "get_tid" => 1,
-  "iget_tid" => 1,
-  "get_lod" => 2,
-  "get_nth" => 3,
-  "get_ipm" => 1,
-  "wai_flg" => 4,
-  "pol_flg" => 4,
-  "twai_flg" => 4,
-  "rcv_dtq" => 2,
-  "prcv_dtq" => 2,
-  "trcv_dtq" => 2,
+$parameterDefinition = {
+  "get_tst" => { 2 => "STAT" },
+  "get_pri" => { 2 => "PRI" },
+  "get_inf" => { 1 => "intptr_t" },
+  "ref_tsk" => { 2 => "T_RTSK" },
+  "ref_sem" => { 2 => "T_RSEM" },
+  "wai_flg" => { 4 => "FLGPTN" },
+  "pol_flg" => { 4 => "FLGPTN" },
+  "twai_flg" => { 4 => "FLGPTN" },
+  "ref_flg" => { 2 => "T_RFLG" },
+  "rcv_dtq" => { 2 => "intptr_t" },
+  "prcv_dtq" => { 2 => "intptr_t" },
+  "trcv_dtq" => { 2 => "intptr_t" },
+  "ref_dtq" => { 2 => "T_RDTQ" },
+  "rcv_pdq" => { 2 => "intptr_t" , 3 => "PRI" },
+  "prcv_pdq" => { 2 => "intptr_t" , 3 => "PRI" },
+  "trcv_pdq" => { 2 => "intptr_t" , 3 => "PRI" },
+  "ref_pdq" => { 2 => "T_RPDQ" },
+  "ref_mtx" => { 2 => "T_RMTX" },
+  "ref_mbf" => { 2 => "T_RMBF" },
+  "get_mpf" => { 2 => "void *" },
+  "pget_mpf" => { 2 => "void *" },
+  "tget_mpf" => { 2 => "void *" },
+  "ref_mpf" => { 2 => "T_RMPF" },
+  "get_tim" => { 1 => "SYSTIM" },
+  "ref_cyc" => { 2 => "T_RCYC" },
+  "ref_alm" => { 2 => "T_RALM" },
+  "ref_ovr" => { 2 => "T_ROVR" },
+  "get_tid" => { 1 => "ID" },
+  "get_did" => { 1 => "ID" },
+  "get_lod" => { 2 => "uint_t" },
+  "mget_lod" => { 3 => "uint_t" },
+  "get_nth" => { 3 => "ID" },
+  "mget_nth" => { 4 => "ID" },
+  "get_ipm" => { 1 => "PRI" },
+  "get_som" => { 1 => "ID" }
 }
 
-$parameterType = {
-  "get_tst" => "STAT",
-  "get_pri" => "PRI",
-  "get_inf" => "intptr_t",
-  "ref_tsk" => "T_RTSK",
-  "ref_sem" => "T_RSEM",
-  "ref_flg" => "T_RFLG",
-  "ref_dtq" => "T_RDTQ",
-  "ref_pdq" => "T_RPDQ",
-  "ref_mtx" => "T_RMTX",
-  "ref_mbf" => "T_RMBF",
-  "ref_mpf" => "T_RMPF",
-  "get_tim" => "SYSTIM",
-  "ref_cyc" => "T_RCYC",
-  "ref_alm" => "T_RALM",
-  "ref_ovr" => "T_ROVR",
-  "get_tid" => "ID",
-  "iget_tid" => "ID",
-  "get_lod" => "uint_t",
-  "get_nth" => "ID",
-  "get_ipm" => "PRI",
-  "wai_flg" => "FLGPTN",
-  "pol_flg" => "FLGPTN",
-  "twai_flg" => "FLGPTN",
-  "rcv_dtq" => "intptr_t",
-  "prcv_dtq" => "intptr_t",
-  "trcv_dtq" => "intptr_t",
-}
-  
 $functionParameters = {
-  "target_hrt_set_event" => "HRTCNT hrtcnt",
+  "target_hrt_set_event" => "HRTCNT hrtcnt"
 }
   
 $functionValue = {
-  "target_hrt_get_current" => "HRTCNT",
+  "target_hrt_get_current" => "HRTCNT"
 }
   
 $functionReturn = {
-  "target_hrt_get_current" => "0U",
+  "target_hrt_get_current" => "0U"
 }
   
 $functionCheckParameter = {
-  "target_hrt_set_event" => "hrtcnt",
+  "target_hrt_set_event" => "hrtcnt"
 }
 
@@ -246,7 +226,13 @@
     print("{\n")
 
-    @variableList.keys.each do |varName|
-      print("\t#{@variableList[varName]}")
-      print(@variableList[varName].length < 4 ? "\t\t" : "\t")
+    @variableList.each do |varName, varType|
+      if /^(.+)\w*\*$/ =~ varType
+        varBaseType = $1
+        print("\t#{varBaseType}")
+        print(varBaseType.length < 4 ? "\t\t*" : "\t*")
+      else
+        print("\t#{varType}")
+        print(varType.length < 4 ? "\t\t" : "\t")
+      end
       print("#{varName};\n")
     end
@@ -296,9 +282,11 @@
     params = $2.split(/\s*,\s*/)
 
-    if !$parameterPosition[svcName].nil? \
-					&& params.size >= $parameterPosition[svcName]
-      varName = params[$parameterPosition[svcName] - 1].sub(/^\&/, "")
-      typeName = $parameterType[svcName]
-      pu.addVariable(varName, typeName)
+    if $parameterDefinition.has_key?(svcName)
+      $parameterDefinition[svcName].each do |pos, type|
+        if params.size >= pos
+          varName = params[pos - 1].sub(/^\&/, "")
+          pu.addVariable(varName, type)
+        end
+      end
     end
   end
